Src/Presentation/3-UI/AdminPanel/Areas/Membership/Controllers/OperatorsController.cs
using TaskoMask.Application.Membership.Operators.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using AutoMapper;
using TaskoMask.Presentation.Framework.Web.Controllers;
using TaskoMask.Application.Share.Dtos.Membership.Operators;
using TaskoMask.Presentation.Framework.Web.Helpers;
using TaskoMask.Application.Share.Dtos.Authorization.Users;
using TaskoMask.Presentation.Framework.Web.Filters;
using TaskoMask.Presentation.Framework.Web.Enums;
using TaskoMask.Presentation.Framework.Web.Extensions;
using TaskoMask.Application.Authorization.Users.Services;

namespace TaskoMask.Presentation.UI.AdminPanle.Areas.Membership.Controllers
{

    [Authorize]
    [Area("Membership")]
    public class OperatorsController : BaseMvcController
    {
        #region Fields

        private readonly IOperatorService _operatorService;
        private readonly IUserService _userService;

        #endregion

        #region Ctor

        public OperatorsController(IOperatorService operatorService, IMapper mapper, IUserService userService) : base(mapper)
        {
            _operatorService = operatorService;
            _userService = userService;
        }

        #endregion

        #region Public Methods





        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            var rolesListQueryResult = await _operatorService.GetListAsync();
            return View(rolesListQueryResult);
        }






        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<ActionResult> Create()
        {
            return View();
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(OperatorUpsertDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _operatorService.CreateAsync(input);
            var redirectUrl = $"/membership/operators/update/EntityId";
            return AjaxResult(cmdResult, redirectUrl: redirectUrl);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Update(string id)
        {
            var @operator = await _operatorService.GetDetailsAsync(id);
            return View(@operator);
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Update(OperatorUpsertDto input)
        {
            ModelState.Remove(nameof(OperatorUpsertDto.Password));
            ModelState.Remove(nameof(OperatorUpsertDto.ConfirmPassword));

            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _operatorService.UpdateAsync(input);
            return AjaxResult(cmdResult);
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ResetPassword(UserResetPasswordDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _userService.ResetPasswordAsync(input.Id,input.NewPassword);
            return AjaxResult(cmdResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> ChangePassword(UserChangePasswordDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _userService.ChangePasswordAsync(input.Id, input.OldPassword, input.NewPassword);
            return AjaxResult(cmdResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [IgnoreAntiforgeryToken]
        public async Task<JavaScriptResult> SetIsActive(string id, bool isActive)
        {
            var cmdResult = await _userService.SetIsActiveAsync(id, isActive);
            return AjaxResult(cmdResult,reloadPage:true);

        }



        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<JavaScriptResult> UpdateRoles(string id, string[]rolesId)
        {
            var cmdResult = await _operatorService.UpdateRolesAsync(id, rolesId);
            return AjaxResult(cmdResult);
        }




        #endregion

        #region Private Methods



        #endregion


    }
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Controllers/RolesController.cs
using TaskoMask.Application.Membership.Roles.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using AutoMapper;
using TaskoMask.Presentation.Framework.Web.Controllers;
using System.Threading.Tasks;
using TaskoMask.Application.Share.Dtos.Membership.Roles;
using TaskoMask.Presentation.Framework.Web.Filters;
using TaskoMask.Presentation.Framework.Web.Extensions;
using TaskoMask.Presentation.Framework.Web.Enums;
using TaskoMask.Presentation.Framework.Web.Helpers;

namespace TaskoMask.Presentation.UI.AdminPanle.Areas.Membership.Controllers
{

    [Authorize]
    [Area("Membership")]
    public class RolesController : BaseMvcController
    {
        #region Fields

        private readonly IRoleService _roleService;

        #endregion

        #region Ctor

        public RolesController(IRoleService roleService, IMapper mapper) : base(mapper)
        {
            _roleService = roleService;
        }

        #endregion

        #region Public Methods


        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            var rolesListQueryResult = await _roleService.GetListAsync();
            return View(rolesListQueryResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<ActionResult> Create()
        {
            return View();
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(RoleUpsertDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _roleService.CreateAsync(input);
            var redirectUrl = $"/membership/roles/update/EntityId";
            return AjaxResult(cmdResult,redirectUrl: redirectUrl);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Update(string id)
        {
            var role = await _roleService.GetDetailsAsync(id);
            return View(role);
        }




        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Update(RoleUpsertDto input)
        {
            if (!ModelState.IsValid)
            {
                var errors = ModelState.GetErrors();
                return ScriptBox.ShowMessage(errors, MessageType.error);
            }

            var cmdResult = await _roleService.UpdateAsync(input);
            return AjaxResult(cmdResult);
        }





        /// <summary>
        /// 
        /// </summary>
        [HttpPost]
        [AjaxOnly]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> UpdatePermissions(string id, string[] PermissionsId)
        {
            var cmdResult = await _roleService.UpdatePermissionsAsync(id, PermissionsId);
            return AjaxResult(cmdResult);
        }



        #endregion

        #region Private Methods



        #endregion


    }
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/Create.cshtml
@model TaskoMask.Application.Share.Dtos.Membership.Roles.RoleUpsertDto

@{
    ViewBag.Title = "Create Role";
}
<div class="grid-50 tablet-grid-50 mobile-grid-100">
    <div class="block">
        <div class="block-content">
            @await Html.PartialAsync("_SaveForm")

        </div>
    </div>
</div>


@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/Index.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Membership.Roles.RoleOutputDto>

@{
    ViewBag.Title = "Roles List";
}

<div class="grid-content">
    <div class="block">
        <div class="block-bar">
            <div class="form">
                <a href="@Url.Action("Create", "Roles", new { })" class="btn btn-success">New Role</a>
            </div>
        </div>
        <div id="ajax-show-list">
            @await Html.PartialAsync("_ItemList", Model)
        </div>
    </div>
</div>


@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/Update.cshtml
@model TaskoMask.Application.Share.ViewModels.RoleDetailsViewModel

@{
    ViewBag.Title = "Update Role";
}


<div class="grid-50 tablet-grid-50 mobile-grid-100">
    <div class="block">
        <div class="block-header">
            <h4>Basic Info</h4>
        </div>
        <div class="block-content">
            @await Html.PartialAsync("_SaveForm", Model.Role)
        </div>
    </div>
</div>

<div class="grid-50 tablet-grid-50 mobile-grid-100">
    <div class="block">
        <div class="block-header">
            <h4>Operators</h4>
        </div>
        <div class="block-content has-table">
            @await Html.PartialAsync("_Operators", Model.Operators)
        </div>
    </div>
</div>

<div class="grid-100 tablet-grid-100 mobile-grid-100">
    <div class="block">
        <div class="block-header">
            <h4>Permissions</h4>
        </div>
        <div class="block-content has-table">
            @await Html.PartialAsync("_UpdatePermissions", Model)
        </div>
    </div>
</div>
@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/_ItemList.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Membership.Roles.RoleOutputDto>
@{
}
@if (Model.Count() == 0)
{
    <div id="no-item-alert-area" class="grid-container">
        <div class="alert alert-info">
            <h4>No item to show!</h4>
        </div>
    </div>
}
else
{
    <div class="block-content has-table">
        <div class="table-responsive">
            <table class="table table-striped table-hover">
                <thead>
                    <tr>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().Name)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().CreationTime.CreateDateTimeString)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().OperatorsCount)</th>
                        <th><label></label></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var item in Model)
                    {

                    <tr data-table-row-id="@item.Id">
                        <td> @item.Name </td>
                        <td> @item.CreationTime.CreateDateTimeString </td>
                        <td> @item.OperatorsCount </td>
                        <td>
                            <div class="btn-group-xs">
                                <a href="@Url.Action( "update", new { id = item.Id }) " class=" btn btn-primary btn-xs btn-xs-circle">
                                    <i class="fa fa-pencil"></i>
                                </a>
                            </div>
                        </td>
                    </tr>
                    }

                </tbody>
            </table>
        </div>
    </div>
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/_Operators.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Membership.Operators.OperatorBasicInfoDto>
@{
}
@if (Model.Count() == 0)
{
    <div id="no-item-alert-area" class="grid-container">
        <div class="alert alert-info">
            <h4>No item to show!</h4>
        </div>
    </div>
}
else
{
    <div class="table-responsive">
        <table class="table table-striped table-hover">
            <thead>
                <tr>
                    <th>@Html.LabelFor(model => model.FirstOrDefault().DisplayName)</th>
                    <th>@Html.LabelFor(model => model.FirstOrDefault().RolesId)</th>
                    <th><label></label></th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model)
                {

                    <tr data-table-row-id="@item.Id">
                        <td>
                            @item.DisplayName
                        </td>
                        <td>
                            @item.RolesId.Count()
                        </td>

                        <td>
                            <div class="btn-group-xs">
                                <a href="@Url.Action( "update","operators", new { id = item.Id }) " class=" btn btn-primary btn-xs btn-xs-circle">
                                    <i class="fa fa-pencil"></i>
                                </a>
                            </div>
                        </td>
                    </tr>
                }

            </tbody>
        </table>
    </div>
}

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/_SaveForm.cshtml
@model TaskoMask.Application.Share.Dtos.Membership.Roles.RoleUpsertDto
@{
}
<form class="form" asp-action="@ViewContext.RouteData.Values["action"]" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">

    <fieldset>
        @Html.AntiForgeryToken()
        @Html.HiddenFor(model => model.Id)

        @Html.LabelFor(model => model.Name)
        @Html.TextBoxFor(model => model.Name, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.Name, "", new { @class = "form-message is-error" })

        @Html.LabelFor(model => model.Description)
        @Html.TextBoxFor(model => model.Description, new { @class = "form-input-1" })
        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "form-message is-error" })

        <hr />

        <button type="submit" class="btn btn-primary">
            Save
        </button>
        <a href="@Url.Action("Index", "Roles", new { })" class="btn btn-default">
            Back
        </a>
    </fieldset>
</form>

Src/Presentation/3-UI/AdminPanel/Areas/Membership/Views/Roles/_UpdatePermissions.cshtml
@model TaskoMask.Application.Share.ViewModels.RoleDetailsViewModel

<div class="table-responsive">
    <form class="form" asp-action="UpdatePermissions" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="Post">

        @Html.AntiForgeryToken()

        <input type="hidden" name="id" value="@Model.Role.Id" />

        @foreach (var group in Model.Permissions)
        {
            <div class="alert alert-info no-pad-tb">
                <h3>@group.Key</h3>
            </div>
            <table class="table table-striped table-bordered">
                <thead>
                    <tr>
                        <th><label></label></th>
                        <th width="50"><label></label></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var permission in group.Value)
                    {
                        <tr>
                            <td>@permission.Text</td>
                            <td><input type="checkbox" name="PermissionsId" value="@permission.Value" checked=@(permission.Selected == true ? "checked" : null ) /></td>
                        </tr>
                    }
                </tbody>
            </table>
        }

        <button type="submit" class="btn btn-primary">
            Save Permissions
        </button>
        <hr />
    </form>

</div>